Roles 1 endpoints

GET /team/{team_id}/customroles

View the Custom Roles available in a Workspace.

operationId: Roles_listAvailableCustomRoles

Parameters

Name In Required Type Description
team_id path required number
include_members query optional boolean

Responses

200
GET /team/{team_id}/customroles

Sharedhierarchy 1 endpoints

GET /team/{team_id}/shared

View the tasks, Lists, and Folders that have been shared with the authenticated user.

operationId: SharedHierarchy_viewTasksListsFolders

Parameters

Name In Required Type Description
team_id path required number

Team ID (Workspace)

Responses

200
GET /team/{team_id}/shared

Spaces 5 endpoints

DELETE /space/{space_id}

Delete a Space from your Workspace.

operationId: Spaces_removeSpace

Parameters

Name In Required Type Description
space_id path required number

Responses

200
DELETE /space/{space_id}
GET /space/{space_id}

View the Spaces available in a Workspace.

operationId: Spaces_getDetails

Parameters

Name In Required Type Description
space_id path required number

Responses

200
GET /space/{space_id}
PUT /space/{space_id}

Rename, set the Space color, and enable ClickApps for a Space.

operationId: Spaces_updateDetailsAndEnableClickApps

Parameters

Name In Required Type Description
space_id path required number

Request Body

required
application/json
schema UpdateSpacerequest
Property Type Required
name string required
color string required
private boolean required
features object required
tags object required
enabled boolean required
due_dates object required
enabled boolean required
start_date boolean required
remap_due_dates boolean required
remap_closed_due_date boolean required
checklists object required
enabled boolean required
portfolios object required
enabled boolean required
custom_fields object required
enabled boolean required
time_tracking object required
enabled boolean required
time_estimates object required
enabled boolean required
dependency_warning object required
enabled boolean required
remap_dependencies object required
enabled boolean required
admin_can_manage boolean required
multiple_assignees boolean required

Responses

200
PUT /space/{space_id}
GET /team/{team_id}/space

View the Spaces avialable in a Workspace. You can only get member info in private Spaces.

operationId: Spaces_getSpaceDetails

Parameters

Name In Required Type Description
team_id path required number

Team ID (Workspace)

archived query optional boolean

Responses

200
GET /team/{team_id}/space
POST /team/{team_id}/space

Add a new Space to a Workspace.

operationId: Spaces_addNewSpaceToWorkspace

Parameters

Name In Required Type Description
team_id path required number

Team ID (Workspace)

Request Body

required
application/json
schema CreateSpacerequest
Property Type Required
name string required
features object required
tags object required
enabled boolean required
due_dates object required
enabled boolean required
start_date boolean required
remap_due_dates boolean required
remap_closed_due_date boolean required
checklists object required
enabled boolean required
portfolios object required
enabled boolean required
custom_fields object required
enabled boolean required
time_tracking object required
enabled boolean required
time_estimates object required
enabled boolean required
dependency_warning object required
enabled boolean required
remap_dependencies object required
enabled boolean required
multiple_assignees boolean required

Responses

200
POST /team/{team_id}/space

Tags 6 endpoints

GET /space/{space_id}/tag

View the task Tags available in a Space.

operationId: Tags_getSpace

Parameters

Name In Required Type Description
space_id path required number

Responses

200
GET /space/{space_id}/tag
POST /space/{space_id}/tag

Add a new task Tag to a Space.

operationId: Tags_createSpaceTag

Parameters

Name In Required Type Description
space_id path required number

Request Body

required
application/json
schema CreateSpaceTagrequest
Property Type Required
tag object required
name string required
tag_bg string required
tag_fg string required

Responses

200
POST /space/{space_id}/tag
DELETE /space/{space_id}/tag/{tag_name}

Delete a task Tag from a Space.

operationId: Tags_removeSpaceTag

Parameters

Name In Required Type Description
space_id path required number
tag_name path required string

Request Body

required
application/json
schema DeleteSpaceTagrequest
Property Type Required
tag object required
name string required
tag_bg string required
tag_fg string required

Responses

200
DELETE /space/{space_id}/tag/{tag_name}
PUT /space/{space_id}/tag/{tag_name}

Update a task Tag.

operationId: Tags_updateSpaceTag

Parameters

Name In Required Type Description
space_id path required number
tag_name path required string

Request Body

required
application/json
schema EditSpaceTagrequest
Property Type Required
tag object required
name string required
bg_color string required
fg_color string required

Responses

200
PUT /space/{space_id}/tag/{tag_name}
DELETE /task/{task_id}/tag/{tag_name}

Remove a Tag from a task. This does not delete the Tag from the Space.

operationId: Tags_removeFromTask

Parameters

Name In Required Type Description
task_id path required string
tag_name path required string
custom_task_ids query optional boolean

If you want to reference a task by it’s custom task id, this value must be true.

team_id query optional number

Only used when the custom_task_ids parameter is set to true.\
\
For example: custom_task_ids=true&team_id=123.

Responses

200
DELETE /task/{task_id}/tag/{tag_name}
POST /task/{task_id}/tag/{tag_name}

Add a Tag to a task.

operationId: Tags_addToTask

Parameters

Name In Required Type Description
task_id path required string
tag_name path required string
custom_task_ids query optional boolean

If you want to reference a task by it’s custom task id, this value must be true.

team_id query optional number

Only used when the custom_task_ids parameter is set to true.\
\
For example: custom_task_ids=true&team_id=123.

Responses

200
POST /task/{task_id}/tag/{tag_name}

Taskchecklists 6 endpoints

DELETE /checklist/{checklist_id}

Delete a checklist from a task.

operationId: TaskChecklists_removeChecklist

Parameters

Name In Required Type Description
checklist_id path required string

b8a8-48d8-a0c6-b4200788a683 (uuid)

Responses

200
DELETE /checklist/{checklist_id}
PUT /checklist/{checklist_id}

Rename a task checklist, or reorder a checklist so it appears above or below other checklists on a task.

operationId: TaskChecklists_updateChecklist

Parameters

Name In Required Type Description
checklist_id path required string

b8a8-48d8-a0c6-b4200788a683 (uuid)

Request Body

required
application/json
schema EditChecklistrequest
Property Type Required
name string optional
position integer optional

Responses

200
PUT /checklist/{checklist_id}
POST /checklist/{checklist_id}/checklist_item

Add a line item to a task checklist.

operationId: TaskChecklists_addLineItem

Parameters

Name In Required Type Description
checklist_id path required string

b8a8-48d8-a0c6-b4200788a683 (uuid)

Request Body

required
application/json
schema CreateChecklistItemrequest
Property Type Required
name string optional
assignee integer optional

Responses

200
POST /checklist/{checklist_id}/checklist_item
DELETE /checklist/{checklist_id}/checklist_item/{checklist_item_id}

Delete a line item from a task checklist.

operationId: TaskChecklists_removeChecklistItem

Parameters

Name In Required Type Description
checklist_id path required string

b8a8-48d8-a0c6-b4200788a683 (uuid)

checklist_item_id path required string

e491-47f5-9fd8-d1dc4cedcc6f (uuid)

Responses

200
DELETE /checklist/{checklist_id}/checklist_item/{checklist_item_id}
PUT /checklist/{checklist_id}/checklist_item/{checklist_item_id}

Update an individual line item in a task checklist. \
\
You can rename it, set the assignee, mark it as resolved, or nest it under another checklist item.

operationId: TaskChecklists_updateChecklistItem

Parameters

Name In Required Type Description
checklist_id path required string

b8a8-48d8-a0c6-b4200788a683 (uuid)

checklist_item_id path required string

e491-47f5-9fd8-d1dc4cedcc6f (uuid)

Request Body

required
application/json
schema EditChecklistItemrequest
Property Type Required
name string optional
parent ["string", "null"] optional
assignee ["string", "null"] optional
resolved boolean optional

Responses

200
PUT /checklist/{checklist_id}/checklist_item/{checklist_item_id}
POST /task/{task_id}/checklist

Add a new checklist to a task.

operationId: TaskChecklists_createNewChecklist

Parameters

Name In Required Type Description
task_id path required string
custom_task_ids query optional boolean

If you want to reference a task by it’s custom task id, this value must be true.

team_id query optional number

Only used when the custom_task_ids parameter is set to true.\
\
For example: custom_task_ids=true&team_id=123.

Request Body

required
application/json
schema CreateChecklistrequest
Property Type Required
name string required

Responses

200
POST /task/{task_id}/checklist

Taskrelationships 4 endpoints

DELETE /task/{task_id}/dependency

Remove the dependency relationship between two or more tasks.

operationId: TaskRelationships_removeDependency

Parameters

Name In Required Type Description
task_id path required string
depends_on query required string
dependency_of query required string
custom_task_ids query optional boolean

If you want to reference a task by it’s custom task id, this value must be true.

team_id query optional number

Only used when the custom_task_ids parameter is set to true.\
\
For example: custom_task_ids=true&team_id=123.

Responses

200
DELETE /task/{task_id}/dependency
POST /task/{task_id}/dependency

Set a task as waiting on or blocking another task.

operationId: TaskRelationships_addDependency

Parameters

Name In Required Type Description
task_id path required string

This is the task which is waiting on or blocking another task.

custom_task_ids query optional boolean

If you want to reference a task by it’s custom task id, this value must be true.

team_id query optional number

Only used when the custom_task_ids parameter is set to true.

For example: custom_task_ids=true&team_id=123.

Request Body

required

Use the depends_on parameter in the request body to specify the task that must be completed before the task in the path parameter.\
\
Use the dependency_of parameter in the request body to specify the task that’s waiting for the task in the path parameter to be completed.\
\
You can only use one per request.

application/json
schema AddDependencyrequest
Property Type Required
depends_on string optional
depedency_of string optional

Responses

200
POST /task/{task_id}/dependency
DELETE /task/{task_id}/link/{links_to}

Remove the link between two tasks.

operationId: TaskRelationships_removeLinkBetweenTasks

Parameters

Name In Required Type Description
task_id path required string
links_to path required string
custom_task_ids query optional boolean

If you want to reference a task by it’s custom task id, this value must be true.

team_id query optional number

Only used when the custom_task_ids parameter is set to true.\
\
For example: custom_task_ids=true&team_id=123.

Responses

200
DELETE /task/{task_id}/link/{links_to}
POST /task/{task_id}/link/{links_to}

Link two tasks together.

operationId: TaskRelationships_linkTasks

Parameters

Name In Required Type Description
task_id path required string
links_to path required string
custom_task_ids query optional boolean

If you want to reference a task by it’s custom task id, this value must be true.

team_id query optional number

Only used when the custom_task_ids parameter is set to true.\
\
For example: custom_task_ids=true&team_id=123.

Responses

200
POST /task/{task_id}/link/{links_to}

Tasktemplates 2 endpoints

POST /list/{list_id}/taskTemplate/{template_id}

Create a new task using a task template.

operationId: TaskTemplates_createFromTemplate

Parameters

Name In Required Type Description
list_id path required number
template_id path required string

Request Body

required
application/json
schema CreateTaskFromTemplaterequest
Property Type Required
name string required

Responses

200
POST /list/{list_id}/taskTemplate/{template_id}
GET /team/{team_id}/taskTemplate

View the task templates available in a Workspace.

operationId: TaskTemplates_getTemplates

Parameters

Name In Required Type Description
team_id path required number

Team ID (Workspace)

page query required integer

Responses

200
GET /team/{team_id}/taskTemplate

Tasks 8 endpoints

GET /list/{list_id}/task

View the tasks in a List. Responses are limited to 100 tasks per page. You can only view task information of tasks you can access. \
\
This endpoint only includes tasks where the specified list_id is their home List. Tasks added to the list_id with a different home List are not included in the response.

operationId: Tasks_getListTasks

Parameters

Name In Required Type Description
list_id path required number

To find the list_id:
1. In the Sidebar, hover over the List and click the ellipsis … menu.
2. Select Copy link.
3. Use the copied URL to find the list_id. The list_id is the number that follows /li in the URL.

archived query optional boolean
include_markdown_description query optional boolean

To return task descriptions in Markdown format, use ?include_markdown_description=true.

page query optional integer

Page to fetch (starts at 0).

order_by query optional string

Order by a particular field. By default, tasks are ordered by created.\
\
Options include: id, created, updated, and due_date.

reverse query optional boolean

Tasks are displayed in reverse order.

subtasks query optional boolean

Include or exclude subtasks. By default, subtasks are excluded.

statuses query optional array

Filter by statuses. To include closed tasks, use the include_closed parameter. \
\
For example: \
\
?statuses[]=to%20do&statuses[]=in%20progress

include_closed query optional boolean

Include or excluse closed tasks. By default, they are excluded.\
\
To include closed tasks, use include_closed: true.

assignees query optional array

Filter by Assignees. For example: \
\
?assignees[]=1234&assignees[]=5678

watchers query optional array

Filter by watchers.

tags query optional array

Filter by tags. For example: \
\
?tags[]=tag1&tags[]=this%20tag

due_date_gt query optional integer

Filter by due date greater than Unix time in milliseconds.

due_date_lt query optional integer

Filter by due date less than Unix time in milliseconds.

date_created_gt query optional integer

Filter by date created greater than Unix time in milliseconds.

date_created_lt query optional integer

Filter by date created less than Unix time in milliseconds.

date_updated_gt query optional integer

Filter by date updated greater than Unix time in milliseconds.

date_updated_lt query optional integer

Filter by date updated less than Unix time in milliseconds.

date_done_gt query optional integer

Filter by date done greater than Unix time in milliseconds.

date_done_lt query optional integer

Filter by date done less than Unix time in milliseconds.

custom_fields query optional array

Include tasks with specific values in multiple Custom Fields.\
\
For example: ?custom_fields=[{"field_id":"abcdefghi12345678","operator":"=","value":"1234"},{"field_id":"jklmnop123456","operator":"<","value":"5"}]\
\
If you want to include tasks with specific values in only one Custom Field, use custom_field instead.\
\
Learn more about filtering using Custom Fields.

custom_items query optional array

Filter by custom task types. For example: \
\
?custom_items[]=0&custom_items[]=1300 \
\
Including 0 returns tasks. Including 1 returns Milestones. Including any other number returns the custom task type as defined in your Workspace.

Responses

200
GET /list/{list_id}/task
POST /list/{list_id}/task

Create a new task.

operationId: Tasks_createNewTask

Parameters

Name In Required Type Description
list_id path required number
custom_task_ids query optional boolean

If you want to reference a task by its custom task id, this value must be true.

team_id query optional number

Only used when the custom_task_ids parameter is set to true.\
\
For example: custom_task_ids=true&team_id=123.

Request Body

required
application/json
schema CreateTaskrequest
Property Type Required
name string required
tags array optional
parent ["string", "null"] optional
status string optional
due_date integer optional
links_to ["string", "null"] optional
priority ["integer", "null"] optional
assignees array optional
notify_all boolean optional
start_date integer optional
description string optional
custom_fields array optional
id string required
value object required
due_date_time boolean optional
time_estimate integer optional
custom_item_id number optional
start_date_time boolean optional
check_required_custom_fields boolean optional

Responses

200
POST /list/{list_id}/task
GET /task/bulk_time_in_status/task_ids

View how long two or more tasks have been in each status. The Total time in Status ClickApp must first be enabled by the Workspace owner or an admin.

operationId: Tasks_getTimeInStatusBulk

Parameters

Name In Required Type Description
task_ids query required string

Include this paramater once per task_id.
You can include up to 100 task ids per request.
For example: task_ids=3cuh&task_ids=g4fs

custom_task_ids query optional boolean

If you want to reference a task by it’s custom task id, this value must be true.

team_id query optional number

Only used when the custom_task_ids parameter is set to true.\
\
For example: custom_task_ids=true&team_id=123.

Responses

200
GET /task/bulk_time_in_status/task_ids
DELETE /task/{task_id}

Delete a task from your Workspace.

operationId: Tasks_removeTaskById

Parameters

Name In Required Type Description
task_id path required string
custom_task_ids query optional boolean

If you want to reference a task by its custom task id, this value must be true.

team_id query optional number

Only used when the custom_task_ids parameter is set to true.\
\
For example: custom_task_ids=true&team_id=123.

Responses

200
DELETE /task/{task_id}
GET /task/{task_id}

View information about a task. You can only view task information of tasks you can access. \
\
Tasks with attachments will return an “attachments” response.

operationId: Tasks_getTaskDetails

Parameters

Name In Required Type Description
task_id path required string
custom_task_ids query optional boolean

If you want to reference a task by its custom task id, this value must be true.

team_id query optional number

Only used when the custom_task_ids parameter is set to true.\
\
For example: custom_task_ids=true&team_id=123.

include_subtasks query optional boolean

Include subtasks, default false

include_markdown_description query optional boolean

To return task descriptions in Markdown format, use ?include_markdown_description=true.

Responses

200
GET /task/{task_id}
PUT /task/{task_id}

Update a task by including one or more fields in the request body.

operationId: Tasks_updateTaskFields

Parameters

Name In Required Type Description
task_id path required string
custom_task_ids query optional boolean

If you want to reference a task by its custom task id, this value must be true.

team_id query optional number

Only used when the custom_task_ids parameter is set to true.\
\
For example: custom_task_ids=true&team_id=123.

Request Body

required

Note: To update Custom Fields on a task, you must use the Set Custom Field endpoint.

application/json
schema UpdateTaskrequest
Property Type Required
name string optional
parent string optional
status string optional
archived boolean optional
due_date integer optional
priority integer optional
watchers object optional
add array required
rem array required
assignees object optional
add array required
rem array required
start_date integer optional
description string optional
due_date_time boolean optional
time_estimate integer optional
custom_item_id ["number", "null"] optional
start_date_time boolean optional

Responses

200
PUT /task/{task_id}
GET /task/{task_id}/time_in_status

View how long a task has been in each status. The Total time in Status ClickApp must first be enabled by the Workspace owner or an admin.

operationId: Tasks_getTimeInStatus

Parameters

Name In Required Type Description
task_id path required string
custom_task_ids query optional boolean

If you want to reference a task by it’s custom task id, this value must be true.

team_id query optional number

Only used when the custom_task_ids parameter is set to true.\
\
For example: custom_task_ids=true&team_id=123.

Responses

200
GET /task/{task_id}/time_in_status
GET /team/{team_Id}/task

View the tasks that meet specific criteria from a Workspace. Responses are limited to 100 tasks per page. \
\
You can only view task information of tasks you can access.

operationId: Tasks_filterTeamTasks

Parameters

Name In Required Type Description
team_Id path required number

Team ID (Workspace)

page query optional integer

Page to fetch (starts at 0).

order_by query optional string

Order by a particular field. By default, tasks are ordered by created.\
\
Options include: id, created, updated, and due_date.

reverse query optional boolean

Tasks are displayed in reverse order.

subtasks query optional boolean

Include or exclude subtasks. By default, subtasks are excluded.

space_ids query optional array

Filter by Spaces. For example: \
\
?space_ids[]=1234&space_ids[]=6789

project_ids query optional array

Filter by Folders. For example: \
\
?project_ids[]=1234&project_ids[]=6789

list_ids query optional array

Filter by Lists. For example: \
\
?list_ids[]=1234&list_ids[]=6789

statuses query optional array

Filter by statuses. Use %20 to represent a space character. To include closed tasks, use the include_closed parameter. \
\
For example: \
\
?statuses[]=to%20do&statuses[]=in%20progress

include_closed query optional boolean

Include or excluse closed tasks. By default, they are excluded.\
\
To include closed tasks, use include_closed: true.

assignees query optional array

Filter by Assignees using people’s ClickUp user id. For example: \
\
?assignees[]=1234&assignees[]=5678

tags query optional array

Filter by tags. User %20 to represent a space character. For example: \
\
?tags[]=tag1&tags[]=this%20tag

due_date_gt query optional integer

Filter by due date greater than Unix time in milliseconds.

due_date_lt query optional integer

Filter by due date less than Unix time in milliseconds.

date_created_gt query optional integer

Filter by date created greater than Unix time in milliseconds.

date_created_lt query optional integer

Filter by date created less than Unix time in milliseconds.

date_updated_gt query optional integer

Filter by date updated greater than Unix time in milliseconds.

date_updated_lt query optional integer

Filter by date updated less than Unix time in milliseconds.

date_done_gt query optional integer

Filter by date done greater than Unix time in milliseconds.

date_done_lt query optional integer

Filter by date done less than Unix time in milliseconds.

custom_fields query optional array

Include tasks with specific values in one or more Custom Fields.\
\
For example: ?custom_fields=[{"field_id":"abcdefghi12345678","operator":"=","value":"1234"}{"field_id":"jklmnop123456","operator":"<","value":"5"}]\
\
Learn more about filtering using Custom Fields.

custom_task_ids query optional boolean

If you want to reference a task by its custom task id, this value must be true.

team_id query optional number

Only used when the custom_task_ids parameter is set to true.\
\
For example: custom_task_ids=true&team_id=123.

parent query optional string

Include the parent task ID to return subtasks.

include_markdown_description query optional boolean

To return task descriptions in Markdown format, use ?include_markdown_description=true.

custom_items query optional array

Filter by custom task types. For example: \
\
?custom_items[]=0&custom_items[]=1300 \
\
Including 0 returns tasks. Including 1 returns Milestones. Including any other number returns the custom task type as defined in your Workspace.

Responses

200
GET /team/{team_Id}/task

Teamsusergroups 4 endpoints

GET /group

This endpoint is used to view Teams: user groups in your Workspace.\
\
In our API documentation, team_id refers to the id of a Workspace, and group_id refers to the id of a user group.

operationId: TeamsUserGroups_getUserGroups

Parameters

Name In Required Type Description
team_id query optional number

Team ID (Workspace)

group_ids query optional string

Enter one or more Team ids (user groups) to retrieve information about specific Teams.

Responses

200
GET /group
DELETE /group/{group_id}

This endpoint is used to remove a Team: user group from your Workspace.\
\
In our API documentation, team_id refers to the id of a Workspace, and group_id refers to the id of a user group.

operationId: TeamsUserGroups_removeGroup

Parameters

Name In Required Type Description
group_id path required string

7C73-4002-A6A9-310014852858 (string) - Team ID (user group)

Responses

200
DELETE /group/{group_id}
PUT /group/{group_id}

This endpoint is used to manage Teams: user groups which are groups of users you can assign items to in your Workspace.\
\
In our API documentation, team_id refers to the id of a Workspace, and group_id refers to the id of a user group.\
\
Note: Adding a guest with view only permissions to a Team automatically converts them to a paid guest.\
\
If you don’t have any paid guest seats available, a new member seat is automatically added to increase the number of paid guest seats available.\
\
This incurs a prorated charge based on your billing cycle.

operationId: TeamsUserGroups_updateUserGroup

Parameters

Name In Required Type Description
group_id path required string

7C73-4002-A6A9-310014852858 (string) - Team ID (user group)

Request Body

required

You can update the team handle which is used to @mention a Team (user group) in your Workspace.\
\
Add or remove members to and from a Team (user group) using the "add" and/or "rem" parameters and including an array of user ids.

application/json
schema UpdateTeamrequest
Property Type Required
name string optional
handle string optional
members object optional
add array required
rem array required

Responses

200
PUT /group/{group_id}
POST /team/{team_id}/group

This endpoint is used to create Teams: user groups which are groups of users you can assign items to in your Workspace.\
\
In our API documentation, team_id refers to the id of a Workspace, and group_id refers to the id of a user group.\
\
Note: Adding a guest with view only permissions to a Team automatically converts them to a paid guest.\
\
If you don’t have any paid guest seats available, a new member seat is automatically added to increase the number of paid guest seats available.\
\
This incurs a prorated charge based on your billing cycle.

operationId: TeamsUserGroups_createTeam

Parameters

Name In Required Type Description
team_id path required number

Team ID (Workspace)

Request Body

required
application/json
schema CreateTeamrequest
Property Type Required
name string required
members array required

Responses

200
POST /team/{team_id}/group

Teamsworkspaces 2 endpoints

GET /team/{team_id}/plan

View the current Plan for the specified Workspace.

operationId: TeamsWorkspaces_getWorkspacePlan

Parameters

Name In Required Type Description
team_id path required string

Team ID (Workspace)

Responses

200
GET /team/{team_id}/plan
GET /team/{team_id}/seats

View the used, total, and available member and guest seats for a Workspace.

operationId: TeamsWorkspaces_getWorkspaceSeats

Parameters

Name In Required Type Description
team_id path required string

Team ID (Workspace)

Responses

200
GET /team/{team_id}/seats

Timetracking 11 endpoints

GET /team/{team_Id}/time_entries

View time entries filtered by start and end date. \
\
By default, this endpoint returns time entries from the last 30 days created by the authenticated user. \
\
To retrieve time entries for other users, you must include the assignee query parameter. \
\
Only one of the following location filters can be included at a time: space_id, folder_id, list_id, or task_id. \
\
Note: A time entry that has a negative duration means that timer is currently running for that user.

operationId: TimeTracking_getTimeEntriesWithinDateRange

Parameters

Name In Required Type Description
team_Id path required number

Team ID (Workspace)

start_date query optional number

Unix time in milliseconds

end_date query optional number

Unix time in milliseconds

assignee query optional number

Filter by user_id. For multiple assignees, separate user_id using commas.\
\
Example: assignee=1234,9876\
\
Note: Only Workspace Owners/Admins have access to do this.

include_task_tags query optional boolean

Include task tags in the response for time entries associated with tasks.

include_location_names query optional boolean

Include the names of the List, Folder, and Space along with the list_id,folder_id, and space_id.

space_id query optional number

Only include time entries associated with tasks in a specific Space.

folder_id query optional number

Only include time entries associated with tasks in a specific Folder.

list_id query optional number

Only include time entries associated with tasks in a specific List.

task_id query optional string

Only include time entries associated with a specific task.

custom_task_ids query optional boolean

If you want to reference a task by it’s custom task id, this value must be true.

team_id query optional number

Only used when the custom_task_ids parameter is set to true.\
\
For example: custom_task_ids=true&team_id=123.

is_billable query optional boolean

Include only billable time entries by using a value of true or only non-billable time entries by using a value of false.\
\
For example: ?is_billable=true.

Responses

200

If your time entry is associated with a task that uses custom task ids you can expect a custom_id` field in the body of the response. The task field will only be included if there is a task associated with a time entry.

GET /team/{team_Id}/time_entries
POST /team/{team_Id}/time_entries

Create a time entry. \
\
Note: A time entry that has a negative duration means that timer is currently running for that user.

operationId: TimeTracking_createTimeEntry

Parameters

Name In Required Type Description
team_Id path required number

Team ID (Workspace)

custom_task_ids query optional boolean

If you want to reference a task by it’s custom task id, this value must be true.

team_id query optional number

Only used when the custom_task_ids parameter is set to true.\
\
For example: custom_task_ids=true&team_id=123.

Request Body

required

Associate a time entry with a task using the tid parameter.

application/json
schema Createatimeentryrequest
Property Type Required
end integer optional
tid string optional
stop integer optional
tags array optional
name string required
tag_bg string required
tag_fg string required
start integer required
assignee integer optional
billable boolean optional
duration integer required
description string optional

Responses

200
POST /team/{team_Id}/time_entries
POST /team/{team_Id}/time_entries/start

Start a timer for the authenticated user.

operationId: TimeTracking_startTimer

Parameters

Name In Required Type Description
team_Id path required number

Team ID (Workspace)

custom_task_ids query optional boolean

If you want to reference a task by it’s custom task id, this value must be true.

team_id query optional number

Only used when the custom_task_ids parameter is set to true.\
\
For example: custom_task_ids=true&team_id=123.

Request Body

required

For Workspaces on the Free Forever or Unlimited Plan, either the timer_id parameter or the "tid" field in the body of the request are required fields.

application/json
schema StartatimeEntryrequest
Property Type Required
tid string optional
tags array optional
name string required
billable boolean optional
description string optional

Responses

200
POST /team/{team_Id}/time_entries/start
GET /team/{team_id}/time_entries/current

View a time entry that’s currently tracking time for the authenticated user. \
\
Note: A time entry that has a negative duration means that timer is currently running for that user.

operationId: TimeTracking_getCurrentTimeEntry

Parameters

Name In Required Type Description
team_id path required number

Team ID (Workspace)

assignee query optional number

user id

Responses

200
GET /team/{team_id}/time_entries/current
POST /team/{team_id}/time_entries/stop

Stop a timer that’s currently running for the authenticated user.

operationId: TimeTracking_stopTimeEntry

Parameters

Name In Required Type Description
team_id path required number

Team ID (Workspace)

Responses

200
POST /team/{team_id}/time_entries/stop
DELETE /team/{team_id}/time_entries/tags

Remove labels from time entries. This does not remove the label from a Workspace.

operationId: TimeTracking_removeTagsFromTimeEntries

Parameters

Name In Required Type Description
team_id path required number

Team ID (Workspace)

Request Body

required
application/json
schema Removetagsfromtimeentriesrequest
Property Type Required
tags array required
name string required
time_entry_ids array required

Responses

200
DELETE /team/{team_id}/time_entries/tags
GET /team/{team_id}/time_entries/tags

View all the labels that have been applied to time entries in a Workspace.

operationId: TimeTracking_getAllTagsFromTimeEntries

Parameters

Name In Required Type Description
team_id path required number

Team ID (Workspace)

Responses

200
GET /team/{team_id}/time_entries/tags
POST /team/{team_id}/time_entries/tags

Add a label to a time entry.

operationId: TimeTracking_addTagsFromTimeEntries

Parameters

Name In Required Type Description
team_id path required number

Team ID (Workspace)

Request Body

required
application/json
schema Addtagsfromtimeentriesrequest
Property Type Required
tags array required
name string required
tag_bg string required
tag_fg string required
time_entry_ids array required

Responses

200
POST /team/{team_id}/time_entries/tags
PUT /team/{team_id}/time_entries/tags

Rename an time entry label.

operationId: TimeTracking_changeTagNames

Parameters

Name In Required Type Description
team_id path required number

Team ID (Workspace)

Request Body

required
application/json
schema Changetagnamesfromtimeentriesrequest
Property Type Required
name string required
tag_bg string required
tag_fg string required
new_name string required

Responses

200
PUT /team/{team_id}/time_entries/tags
DELETE /team/{team_id}/time_entries/{timer_id}

Delete a time entry from a Workspace.

operationId: TimeTracking_removeEntry

Parameters

Name In Required Type Description
team_id path required number

Team ID (Workspace)

timer_id path required number

Array of timer ids to delete separated by commas

Responses

200
DELETE /team/{team_id}/time_entries/{timer_id}
GET /team/{team_id}/time_entries/{timer_id}

View a single time entry. \
\
Note: A time entry that has a negative duration means that timer is currently running for that user.

operationId: TimeTracking_getSingleTimeEntry

Parameters

Name In Required Type Description
team_id path required number

Team ID (Workspace)

timer_id path required string

The ID of a time entry. \
\
This can be found using the Get Time Entries Within a Date Range endpoint.

include_task_ query optional boolean

Include task in the response for time entries associated with tasks.

include_location_names query optional boolean

Include the names of the List, Folder, and Space along with list_id,folder_id, and space_id.

Responses

200
GET /team/{team_id}/time_entries/{timer_id}
Load more endpoints